<?php

include('../config/config.php');
include('html/html.inc.php');
include('includes/functions.php');
include('includes/tmhOAuth.php');
include('../includes/classes/class.Tweet.php');
include('../includes/classes/class.User.php');
checkLoginAdmin();

$objUser=new User();
$objTweet=new Tweet();

if ( isset($_POST['submit']) )
{

  $screen_name=clean($_POST['username']);
  $exist=$objUser->checkUserExist($screen_name);
  	
  if($exist)
  {	
	  $connection = new tmhOAuth(array( 'consumer_key' => $consumer_key, 'consumer_secret' => $consumer_secret, 'user_token' => $user_token, 'user_secret' => $user_secret ));
	  $http_code = $connection->request('GET',$connection->url('1.1/statuses/user_timeline'), array('screen_name' => $screen_name,'count'=>200));
	
	  if ($http_code == 200) 
	  {
		 $tweet_data = json_decode($connection->response['response'],true); 
		 
		 $userArray=array();
		 foreach($tweet_data as $user) 
		 { 
		   $userArray=$user['user'];
		 }
		 
		 $objUser->id=$userArray['id_str'];
		 $objUser->screen_name=$screen_name;
		 $objUser->name=$userArray['name'];
		 $objUser->profile_image_url=$userArray['profile_image_url'];
		 $objUser->location=$userArray['location'];
		 $objUser->created_at=date('y-m-d h:m:s',strtotime($userArray['created_at']));
		 $objUser->friends_count=$userArray['friends_count'];
		 $objUser->followers_count=$userArray['followers_count'];
		 $objUser->statuses_count=$userArray['statuses_count'];
		 $objUser->addUserAccount();
		 
		 foreach($tweet_data as $tweet)
		 {
			 if(isset($tweet['retweeted_status']))
			 {
				 continue;
			 }
			 
			 $objTweet->id=$tweet['id_str'];
			 $objTweet->tweet_text=base64_encode($tweet['text']);
			 $objTweet->created_at=date('y-m-d h:m:s',strtotime($tweet['created_at']));
			 $objTweet->user_id=$userArray['id_str'];
			 $objTweet->saveTweet();
		 }
		 
		 $redirectUrl = 'view-accounts.php';
		 $_SESSION['succesMessage'] = 4;
		 header("Location: $redirectUrl");
		 exit;
	   } 
	   else 
	   { 
		if ($http_code == 429) 
		{ 
		  $_SESSION['errorMessage'] = 2;
		  $redirectUrl = 'add-account.php';
		  header("Location: $redirectUrl");
		  exit;
		} 
		else 
		{
		  $_SESSION['errorMessage'] = 3;
		  $redirectUrl = 'add-account.php';
		  header("Location: $redirectUrl");
		  exit; 
		} 
	  }
  }
  else 
  {
	$_SESSION['errorMessage'] = 4;
	$redirectUrl = 'add-account.php';
	header("Location: $redirectUrl");
	exit; 
  }
}

startHtml($title = "Add Twitter Account");
tophead($title);
leftNav();
?>
 
<script src="<?php echo ADMIN_JS;?>accounts.js" type="text/javascript"></script>

<?php
	if ( isset($_SESSION['succesMessage']) )
	{
		successMsg($_SESSION['succesMessage']);
		unset($_SESSION['succesMessage']);
	}
	else if(isset($_SESSION['errorMessage']))
	{
		errorMsg($_SESSION['errorMessage']);
		unset($_SESSION['errorMessage']);
	}
?>
<section id="main" class="column">
    <article class="module width_half">
        <header>
            <h3>Add Twitter Account</h3>
        </header>
        <form name="addAccount" id="addAccount" action="" method="post">
            <fieldset style="margin:15px">
                <table width="100%">
                	<tr>
                    	<td>
                        	<label>Twitter Username</label>
                			<input type="text" name="username" id="username" value=""/>
                        </td>
                    </tr>
                    <tr>
                    	<td>
                        	<input type="submit" name="submit" id="submit" value="Add Account" />
                			<input type="button" name="cancel" id="cancel" value="Cancel" onclick="window.location='<?php echo ADMIN_URL."view-accounts.php";?>'" />
                        </td>
                    </tr>
                </table>
            </fieldset>
        </form>
    </article>
    <div class="spacer"></div>
</section>
<?php
endHtml();
?>
